/*
Design


(C) J Whitham 1994
*/

#include <fastgraf.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>

#define GridSize	( 16 )
#define SqSize		( 16 )
#define Available ( 255 )

unsigned char		Grid [ GridSize ][ GridSize ] ;
unsigned char		Restore [ GridSize ][ GridSize ] ;
char					Filename [ 15 ] ;
FILE					* File ;

void Save ( void ) ;
void Update ( int X , int Y ) ;
void MouseAt ( int X , int Y ) ;

void main ( int arg_c , char * arg_v [] )
{
	int					I , X , Y ;
	unsigned char		CurrentColor = 15 ;
	char					Temp [ 10 ] ;
	int					Change , Quit = 0 ;
	int				  	Picked ;
	int					ch ;
	int					X2 , Y2 ;

	if ( ! fg_testmode ( 18 , 1 ) )
	{
		printf ( "VGA required." ) ;
		exit ( 0 ) ;
	}
	Picked = 0 ;
	if ( arg_c == 2 )
	{
		printf ( "\a" ) ;
		Picked = atoi ( arg_v [ 1 ] ) ;
		if ( Picked < 1 || Picked > 255 )
		{
			printf ( "If you supply a parameter it must be from 1-255." ) ;
			exit ( 0 ) ;
		}
	}

	fg_setmode ( 18 ) ;
	fg_setrgb ( 1 , 0 , 0 , 0 ) ;
	fg_fontsize ( 16 ) ;
	fg_move ( 216 , 248 ) ;
	fg_setcolor ( 1 ) ;
	fg_print ( "DESIGN  (C) J Whitham 1994" , 26 ) ;
	for ( I = 0 ; I < 63 ; I ++ )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}
	fg_waitfor ( 18 ) ;
	for ( ; I > 0 ; I -- )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}
	fg_setmode ( 3 ) ;
	if ( Picked == 0 )
	{
		printf ( "SELECT A CHARACTER\n\n" ) ;
		printf ( "Use left and right arrow keys to select\n" ) ;
		printf ( "Use up and down arrows keys to speed select\n" ) ;
		printf ( "Press SPACE bar when finished.\n\n" ) ;

		I = 1 ;
		Change = 1 ;
		ch = 0 ;
		while ( ch != 32 )
		{
			if ( Change )
			{
				printf ( "\r< %3d >" , I ) ;
				Change = 0 ;
			}
			ch = getch () ;
			if ( ch == 27 )
			{
				printf ( "\n\n" ) ;
				exit ( 0 ) ;
			}
			if ( ch == 0 )
			{
				switch ( getch () )
				{
					case 80 :	I -= 5 ;
									break ;
					case 72 :	I += 5 ;
									break ;
					case 75 :	I -- ;
									break ;
					case 77 :	I ++ ;
									break ;
				}
			}
			if ( I < 1 )
			{
				I += Available ;
			}
			if ( I > Available )
			{
				I -= Available ;
			}
		}
		Picked = I ;
	}

	sprintf ( Filename , "GAMECHR.%d" , Picked ) ;

	if (( File = fopen ( Filename , "rb" ) ) != NULL )
	{
		if ( fread ( Grid , sizeof ( Grid ) , 1 , File ) != 1 )
		{
			printf ( "\n\nCouldn't read %s" , Filename ) ;
			exit ( 0 ) ;
		}
		fclose ( File ) ;
		Save () ;
	}

	fg_setmode ( 18 ) ;

	for ( I = 0 ; I < 16 ; I ++ )
	{
		fg_setcolor ( I ) ;
		fg_rect ( I * 40 , ( I * 40 ) + 39 , 400 , 479 ) ;
		fg_setcolor ( 15 ) ;
		fg_box ( I * 40 , ( I * 40 ) + 39 , 400 , 479 ) ;
	}
	fg_setcolor ( 4 ) ;
	fg_rect ( 500 , 600 , 0 , 50 ) ;
	fg_rect ( 500 , 600 , 100 , 150 ) ;
	fg_rect ( 500 , 600 , 200 , 250 ) ;
	fg_rect ( 500 , 600 , 300 , 350 ) ;
	fg_setcolor ( 15 ) ;
	fg_box ( 500 , 600 , 0 , 50 ) ;
	fg_box ( 500 , 600 , 100 , 150 ) ;
	fg_box ( 500 , 600 , 200 , 250 ) ;
	fg_box ( 500 , 600 , 300 , 350 ) ;
	fg_fontsize ( 16 ) ;
	fg_move ( 505 , 33 ) ;
	fg_print ( "QUIT" , 4 ) ;
	fg_move ( 505 , 133 ) ;
	fg_print ( "SAVE" , 4 ) ;
	fg_move ( 505 , 233 ) ;
	fg_print ( "ERASE" , 5 ) ;
	fg_move ( 505 , 333 ) ;
	fg_print ( "RESTORE" , 7 ) ;
	fg_setcolor ( CurrentColor ) ;
	fg_rect ( 340 , 400 , 50 , 80 ) ;
	fg_setcolor ( 14 ) ;
	fg_box ( 50 , 100 , 340 , 390 ) ;
	fg_setcolor ( 7 ) ;
	for ( X = 0 ; X < GridSize ; X ++ )
	{
		for ( Y = 0 ; Y < GridSize ; Y ++ )
		{
			fg_box ( ( X * SqSize ) + 5 , ( X * SqSize ) + 5 + SqSize ,
						( Y * SqSize ) + 5 , ( Y * SqSize ) + 5 + SqSize ) ;
			Update ( X , Y ) ;
			fg_setcolor ( 7 ) ;
		}
	}
	X = 320 ;
	Y = 240 ;
	Quit = 0 ;
	fg_kbinit ( 1 ) ;
	while ( ! Quit )
	{
		if ( fg_kbtest ( 72 ) )
		{
			Y -- ;
		} else {
			if ( fg_kbtest ( 80 ) )
			{
				Y ++ ;
			}
		}
		if ( fg_kbtest ( 75 ) )
		{
			X -- ;
		} else {
			if ( fg_kbtest ( 77 ) )
			{
				X ++ ;
			}
		}
		if ( fg_kbtest ( 1 ) )
		{
			Quit = 1 ;
		}
		if ( fg_kbtest ( 59 ) )
		{
			Save () ;
		}
		if ( fg_kbtest ( 57 ) )
		{
			Press = 1 ;
		}
		if ( X < 0 )
		{
			X = 0 ;
		}
		if ( Y < 0 )
		{
			Y = 0 ;
		}
		if ( X > 639 )
		{
			X = 639 ;
		}
		if ( Y > 479 )
		{
			Y = 479 ;
		}

		if ( Press > 0 )
		{
			if ( Y > 400 ) /* it's a COLOR */
			{
				CurrentColor = X / 40 ;
				fg_setcolor ( CurrentColor ) ;
				fg_rect ( 340 , 400 , 50 , 80 ) ;
			} else {
				if ( X > 500 && X < 600 ) /* Quit, Save or Erase */
				{
					if ( Y > 0 && Y < 50 ) /* Quit */
					{
						Quit = 1 ;
					} else {
						if ( Y > 100 && Y < 150 ) /* Save */
						{
							Save () ;
						} else {
							if ( Y > 200 && Y < 250 ) /* Erase */
							{
								for ( X2 = 0 ; X2 < GridSize ; X2 ++ )
								{
									for ( Y2 = 0 ; Y2 < GridSize ; Y2 ++ )
									{
										Grid [ X2 ][ Y2 ] = CurrentColor ;
										Update ( X2 , Y2 ) ;
									}
								}
							} else {
								if ( Y > 300 && Y < 350 ) /* Restore */
								{
									for ( X2 = 0 ; X2 < GridSize ; X2 ++ )
									{
										for ( Y2 = 0 ; Y2 < GridSize ; Y2 ++ )
										{
											Grid [ X2 ][ Y2 ] = Restore [ X2 ][ Y2 ] ;
											Update ( X2 , Y2 ) ;
										}
									}
								}
							}
						}
					}
				} else {
					if ( X < ( GridSize * SqSize ) + 5
					&& Y < ( GridSize * SqSize ) + 5 )
					{
						/* Change grid setting at this point */
						X2 = ( X - 5 ) / SqSize ;
						Y2 = ( Y - 5 ) / SqSize ;
						Grid [ X2 ][ Y2 ] = CurrentColor ;
						Update ( X2 , Y2 ) ;
					}
				}
			}
			while ( fg_kbtest ( 32 ) )
			{
			}
		}
		MouseAt ( X , Y ) ;
	}
	fg_setmode ( 3 ) ;
}


void Update ( int X , int Y )
{
	fg_setcolor ( Grid [ X ][ Y ] ) ;
	fg_rect ( ( X * SqSize ) + 6 , ( X * SqSize ) + 4 + SqSize ,
				( Y * SqSize ) + 6 , ( Y * SqSize ) + 4 + SqSize ) ;
	fg_move ( X + ( 75 - ( SqSize / 2 )) , Y + ( 365 - ( SqSize / 2 )) ) ;
	fg_drawrel ( 0 , 0 ) ;
}

void Save ( void )
{
	int		X2 , Y2 ;

	for ( X2 = 0 ; X2 < GridSize ; X2 ++ )
	{
		for ( Y2 = 0 ; Y2 < GridSize ; Y2 ++ )
		{
			Restore [ X2 ][ Y2 ] = Grid [ X2 ][ Y2 ] ;
		}
	}
	if (( File = fopen ( Filename , "wb" ) ) == NULL )
	{
		fg_setmode ( 3 ) ;
		printf ( "Open error 1" ) ;
		exit ( 0 ) ;
	}
	if ( fwrite ( Grid , sizeof ( Grid ) , 1 , File ) != 1 )
	{
		fg_setmode ( 3 ) ;
		printf ( "Couldn't write %s" , Filename ) ;
		exit ( 0 ) ;
	}
	fclose ( File ) ;
}

void MouseAt ( int X , int Y )
{
	char		Was [ 128 ] ;

	fg_move ( X - 8 , Y + 8 ) ;
	fg_getimage ( Was , 8 , 16 ) ;
	fg_setcolor ( 14 ) ;
	fg_move ( X - 8 , Y + 8 ) ;
	fg_draw ( X + 7 , Y - 7 ) ;
	fg_move ( X - 8 , Y - 7 ) ;
	fg_draw ( X + 7 , Y + 8 ) ;
	fg_move ( X - 8 , Y + 8 ) ;
	fg_putimage ( Was , 8 , 16 ) ;
}

