/*
(C) J Whitham 1994


Amulet
*/

#include <fastgraf.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>

#define GridSize	( 16 )
#define SqSize		( 16 )
#define SectFrames ( 124 )
#define Sects		( 12 )
#define Files		( 255 )
#define BenchmarkTime	( 2000 )
#define FrameRate			( 20 )
/*
breif:

Sect [ 0 ][ X ][ Y ] is always Home [ X ][ Y ]
After playing animation & reaching blank frame || end of space
program always returns to HomeFrame. (0). All Sects start with
the home frame applying to their character.

Size of Sect is 32K.
*/

typedef struct {
								int			Speed ;
								int			Delay [ 6 ] ;
								} BENCHMARK_RESULT ;


unsigned char		Sect [ SectFrames + 1 ][ GridSize ][ GridSize ] ;
unsigned char		HomeGrid [ GridSize ][ GridSize ] ;

char					Filename [ 15 ] ;
char					HomeFilename [ 15 ] ;
FILE					* File ;
unsigned char		CurrentColor = 15 ;
unsigned char		EchoColor = 1 ;
unsigned char		Drag = 0 ;
char					Temp [ 40 ] ;
int					Change , Quit = 0 ;
int					Frame = 0 ;
int					Character ;
int					Section ;
BENCHMARK_RESULT	BenchmarkResult ;

void Save ( void ) ;
void Update ( int X , int Y ) ;
void UpdateDrag ( void ) ;
void UpdateEchoColor ( void ) ;
void UpdateFrame ( void ) ;
void UpdateAll ( void ) ;
void UpdateCurrentColor ( void ) ;
int Benchmark ( BENCHMARK_RESULT * BM ) ;
void Play ( void ) ;
void MouseAt ( int X , int Y ) ;

void main ( void )
{
	int					I , X , Y ;
	int					Press ;
	int					X2 , Y2 ;

	if ( ! fg_testmode ( 18 , 1 ) )
	{
		printf ( "VGA required." ) ;
		exit ( 0 ) ;
	}
	I = Benchmark ( & BenchmarkResult ) ;
/*	fg_setmode ( 3 ) ;
	printf ( "Returned: %d" , I ) ;
	printf ( "FrameSpeed: %d\n" , BenchmarkResult . Speed ) ;
	for ( I = 1 ; I < 6 ; I ++ )
	{
		printf ( "%d = %d\n" , I , BenchmarkResult . Delay [ I ] ) ;
	}
	fg_waitkey () ;
	exit ( 0 ) ;   */
	fg_erase () ;
	fg_setrgb ( 1 , 0 , 0 , 0 ) ;
	fg_fontsize ( 16 ) ;
	fg_move ( 216 , 248 ) ;
	fg_setcolor ( 1 ) ;
	fg_print ( "DESIGNA (C) J Whitham 1994" , 26 ) ;
	sprintf ( Temp , "Your machine's benchmark is %d\%" ,
					BenchmarkResult . Delay [ 1 ] * 2 ) ;
	fg_move ( 160 - ( strlen ( Temp ) * 4 ) , 310 ) ;
	fg_print ( Temp , strlen ( Temp ) ) ;

	for ( I = 0 ; I < 63 ; I ++ )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}
	fg_waitfor ( 18 ) ;
	for ( ; I > 0 ; I -- )
	{
		fg_setrgb ( 1 , I , 0 , I ) ;
	}
	fg_setmode ( 3 ) ;

	printf ( "SELECT A FIGURE (CHARACTER)\n\n" ) ;
	printf ( "Use left and right arrow keys to select\n" ) ;
	printf ( "Use up and down arrow keys to speed select\n" ) ;
	printf ( "Use SPACE bar to edit\n\n" ) ;

	ch = 0 ;
	I = 1 ;
	Change = 1 ;
	while ( ch != 32 )
	{
		if ( Change )
		{
			printf ( "\r< %3d >" , I ) ;
			Change = 0 ;
		}
		ch = getch () ;
		if ( ch == 27 )
		{
			printf ( "\n\n" ) ;
			exit ( 0 ) ;
		}
		if ( ch == 0 )
		{
			switch ( (unsigned char) getch () )
			{
				case 80 :	I -= 5 ;
								Change = 1 ;
								break ;
				case 72 :	I += 5 ;
								Change = 1 ;
								break ;
				case 75 :	I -- ;
								Change = 1 ;
								break ;
				case 77 :	I ++ ;
								Change = 1 ;
								break ;
			}
		}
		if ( I < 1 )
		{
			I += Files ;
		}
		if ( I > Files )
		{
			I -= Files ;
		}
	}
	Character = I ;

	fg_erase () ;
	while ( kbhit () )
	{
		(void) getch () ;
	}

	printf ( "NOW SELECT A SECTION\n\n" ) ;

	Change = 1 ;
	I = 1 ;
	ch = 0 ;
	while ( ch != 32 )
	{
		if ( Change )
		{
			printf ( "\r< %3d >" , I ) ;
			Change = 0 ;
		}
		ch = getch () ;
		if ( ch == 27 )
		{
			printf ( "\n\n" ) ;
			exit ( 0 ) ;
		}
		if ( ch == 0 )
		{
			switch ( getch () )
			{
				case 80 :	I -= 5 ;
								Change = 1 ;
								break ;
				case 72 :	I += 5 ;
								Change = 1 ;
								break ;
				case 75 :	I -- ;
								Change = 1 ;
								break ;
				case 77 :	I ++ ;
								Change = 1 ;
								break ;
			}
		}
		if ( I < 1 )
		{
			I += Sects ;
		}
		if ( I > Sects )
		{
			I -= Sects ;
		}
	}
	Section = I ;

	sprintf ( Filename , "ANIM_%d.%d" , Character , Section ) ;

	if (( File = fopen ( Filename , "rb" ) ) != NULL )
	{
		if ( fread ( Sect , sizeof ( Sect ) , 1 , File ) != 1 )
		{
			fg_setmode ( 3 ) ;
			printf ( "Couldn't read %s" , Filename ) ;
			exit ( 0 ) ;
		}
		fclose ( File ) ;
	}

	sprintf ( HomeFilename , "ANIM_%d.RTN" , Character ) ;

	if (( File = fopen ( HomeFilename , "rb" ) ) != NULL )
	{
		if ( fread ( HomeGrid , sizeof ( HomeGrid ) , 1 , File ) != 1 )
		{
			fg_setmode ( 3 ) ;
			printf ( "Couldn't read %s" , HomeFilename ) ;
			exit ( 0 ) ;
		}
	}

	for ( X = 0 ; X < GridSize ; X ++ )
	{
		for ( Y = 0 ; Y < GridSize ; Y ++ )
		{
			Sect [ 0 ][ X ][ Y ] = HomeGrid [ X ][ Y ] ;
		}
	}
	Save () ;

	fg_setmode ( 18 ) ;

	for ( I = 0 ; I < 16 ; I ++ )
	{
		fg_setcolor ( I ) ;
		fg_rect ( I * 40 , ( I * 40 ) + 39 , 400 , 479 ) ;
		fg_setcolor ( 15 ) ;
		fg_box ( I * 40 , ( I * 40 ) + 39 , 400 , 479 ) ;
	}
	fg_setcolor ( 4 ) ;
	fg_rect ( 500 , 600 , 0 , 50 ) ;    /* Quit */
	fg_rect ( 500 , 600 , 100 , 150 ) ; /* Fill */
	fg_rect ( 500 , 600 , 200 , 250 ) ; /* Drag */
	fg_rect ( 500 , 600 , 300 , 350 ) ; /* Set echo color */
	fg_rect ( 350 , 450 , 0 , 50 ) ;    /* Play sect */
	fg_rect ( 350 , 450 , 100 , 150 ) ; /* Save */
	fg_rect ( 350 , 450 , 200 , 250 ) ; /* << */
	fg_rect ( 350 , 450 , 300 , 350 ) ; /* >> */
	fg_rect ( 200 , 300 , 300 , 350 ) ; /* Copy last frame */
	fg_setcolor ( 15 ) ;
	fg_move ( 510 , 40 ) ;
	fg_print ( "QUIT" , 4 ) ;
	fg_move ( 510 , 140 ) ;
	fg_print ( "FILL" , 4 ) ;
	fg_move ( 510 , 240 ) ;
	fg_print ( "DRAG" , 4 ) ;
	fg_move ( 510 , 340 ) ;
	fg_print ( "SET ECHO" , 8 ) ;
	fg_move ( 360 , 40 ) ;
	fg_print ( "PLAY" , 4 ) ;
	fg_move ( 360 , 140 ) ;
	fg_print ( "SAVE" , 4 ) ;
	fg_move ( 360 , 240 ) ;
	fg_print ( "BACK <<" , 7 ) ;
	fg_move ( 360 , 340 ) ;
	fg_print ( "FWD  >>" , 7 ) ;
	fg_move ( 210 , 340 ) ;
	fg_print ( "COPY LAST" , 9 ) ;

	EchoColor = 1 ;
	UpdateDrag () ;
	UpdateEchoColor () ;
	UpdateCurrentColor () ;
	UpdateFrame () ;
	UpdateAll () ;
	fg_setcolor ( 14 ) ;
	fg_box ( 50 , 100 , 340 , 390 ) ;
	fg_setcolor ( 7 ) ;
	for ( X = 0 ; X < GridSize ; X ++ )
	{
		for ( Y = 0 ; Y < GridSize ; Y ++ )
		{
			fg_box ( ( X * SqSize ) + 5 , ( X * SqSize ) + 5 + SqSize ,
						( Y * SqSize ) + 5 , ( Y * SqSize ) + 5 + SqSize ) ;
		}
	}
	UpdateAll () ;
	Quit = 0 ;
	while ( ! Quit )
	{
		if ( fg_kbtest ( 72 ) )
		{
			Y -- ;
		} else {
			if ( fg_kbtest ( 80 ) )
			{
				Y ++ ;
			}
		}
		if ( fg_kbtest ( 75 ) )
		{
			X -- ;
		} else {
			if ( fg_kbtest ( 77 ) )
			{
				X ++ ;
			}
		}
		if ( fg_kbtest ( 57 ) )
		{
			Press = 1 ;
		} else {
			Press = 0 ;
		}
		if ( fg_kbtest ( 1 ) )
		{
			Quit = 1 ;
		}
		if ( fg_kbtest ( 59 ) )
		{
			Save () ;
		}

		if ( Press > 0 )
		{
			if ( Y > 400 ) /* it's a COLOR */
			{
				CurrentColor = X / 40 ;
				UpdateCurrentColor () ;
			} else {
				if ( X > 350 && X < 450 )
				{
					if ( Y > 0 && Y < 50 ) /* Play */
					{
						Play () ;
					}
					if ( Y > 100 && Y < 150 ) /* Save */
					{
						Save () ;
					}
					if ( Y > 200 && Y < 250 ) /* << */
					{
						Frame -- ;
						if ( Frame < 0 )
						{
							Frame = SectFrames ;
						}
						UpdateAll () ;
						UpdateFrame () ;
					}
					if ( Y > 300 && Y < 350 ) /* >> */
					{
						Frame ++ ;
						if ( Frame > SectFrames )
						{
							Frame = 0 ;
						}
						UpdateAll () ;
						UpdateFrame () ;
					}
				} else {
					if ( X > 500 && X < 600 )
					{
						if ( Y > 0 && Y < 50 ) /* Quit */
						{
							Quit = 1 ;
						}
						if ( Y > 100 && Y < 150 ) /* Fill */
						{
							for ( X = 0 ; X < GridSize ; X ++ )
							{
								for ( Y = 0 ; Y < GridSize ; Y ++ )
								{
									Sect [ Frame ][ X ][ Y ] = CurrentColor ;
									Update ( X , Y ) ;
								}
							}
						}
						if ( Y > 200 && Y < 250 ) /* Drag */
						{
							if ( Drag )
							{
								Drag = 0 ;
							} else {
								Drag = 1 ;
							}
							UpdateDrag () ;
						}
						if ( Y > 300 && Y < 350 ) /* Set echo */
						{
							EchoColor = CurrentColor ;
							UpdateEchoColor () ;
							UpdateAll () ;
						}
					} else {
						if ( X < ( GridSize * SqSize ) + 5
						&& Y < ( GridSize * SqSize ) + 5 )
						{
							/* Change grid setting at this point */
							X2 = ( X - 5 ) / SqSize ;
							Y2 = ( Y - 5 ) / SqSize ;
							Sect [ Frame ][ X2 ][ Y2 ] = CurrentColor ;
							Update ( X2 , Y2 ) ;
						} else {
							if ( ( X > 200 && X < 300 )
							&& ( Y > 300 && Y < 350 ) )
							{
								if ( Frame > 0 )
								{
									for ( X2 = 0 ; X2 < GridSize ; X2 ++ )
									{
										for ( Y2 = 0 ; Y2 < GridSize ; Y2 ++ )
										{
											Sect [ Frame ][ X2 ][ Y2 ] =
													Sect [ Frame - 1 ][ X2 ][ Y2 ] ;
											Update ( X2 , Y2 ) ;
										}
									}
								}
							}
						}
					}
				}
			}
			if ( X < ( GridSize * SqSize )
			&& Y < ( GridSize * SqSize ))
			{
				if ( ! Drag )
				{
					while ( fg_kbtest ( 57 ) )
					{
						MouseAt ( X , Y ) ;
					}
				}
			} else {
				while ( fg_kbtest ( 57 ) )
				{
					MouseAt ( X , Y ) ;
				}
			}
		}
	}
	fg_setmode ( 3 ) ;
	fg_kbinit ( 0 ) ;
}


void Update ( int X , int Y )
{
	int		LastFrame = Frame - 1 ;
	int		Drawn = 0 ;

	if ( LastFrame > -1 )
	{
		fg_setcolor ( EchoColor ) ;
		if ( Sect [ LastFrame ][ X ][ Y ] > 0 )
		{
			fg_rect ( ( X * SqSize ) + 6 , ( X * SqSize ) + 4 + SqSize ,
						( Y * SqSize ) + 6 , ( Y * SqSize ) + 4 + SqSize ) ;
			Drawn = 1 ;
		}
	}
	fg_setcolor ( Sect [ Frame ][ X ][ Y ] ) ;
	if (( Sect [ Frame ][ X ][ Y ] > 0 )
	|| ! Drawn )
	{
		fg_rect ( ( X * SqSize ) + 6 , ( X * SqSize ) + 4 + SqSize ,
					( Y * SqSize ) + 6 , ( Y * SqSize ) + 4 + SqSize ) ;
	}
	fg_move ( X + ( 75 - ( SqSize / 2 )) , Y + ( 365 - ( SqSize / 2 )) ) ;
	fg_drawrel ( 0 , 0 ) ;
}

void Save ( void )
{
	int		X , Y ;

	for ( X = 0 ; X < GridSize ; X ++ )
	{
		for ( Y = 0 ; Y < GridSize ; Y ++ )
		{
			HomeGrid [ X ][ Y ] = Sect [ 0 ][ X ][ Y ] ;
		}
	}
	if (( File = fopen ( Filename , "wb" ) ) == NULL )
	{
		fg_setmode ( 3 ) ;
		printf ( "Open error 1" ) ;
		exit ( 0 ) ;
	}
	fwrite ( Sect , sizeof ( Sect ) , 1 , File ) ;
	fclose ( File ) ;
	if (( File = fopen ( HomeFilename , "wb" ) ) == NULL )
	{
		fg_setmode ( 3 ) ;
		printf ( "Open error 2" ) ;
		exit ( 0 ) ;
	}
	fwrite ( HomeGrid , sizeof ( HomeGrid ) , 1 , File ) ;
	fclose ( File ) ;
}

void UpdateEchoColor ( void )
{
	fg_setcolor ( EchoColor ) ;
	fg_rect ( 610 , 620 , 300 , 350 ) ;
}

void UpdateFrame ( void )
{
	fg_setcolor ( 0 ) ;
	fg_rect ( 320 , 350 , 375 , 390 ) ;
	fg_move ( 320 , 390 ) ;
	fg_setcolor ( 14 ) ;
	fg_fontsize ( 16 ) ;
	if ( Frame > 0 )
	{
		sprintf ( Temp , "%d  " , Frame ) ;
	} else {
		strcpy ( Temp , "HOME" ) ;
	}
	fg_print ( Temp , 4 ) ;
}

void UpdateAll ( void )
{
	int		X , Y ;

	for ( X = 0 ; X < GridSize ; X ++ )
	{
		for ( Y = 0 ; Y < GridSize ; Y ++ )
		{
			Update ( X , Y ) ;
		}
	}
}

void UpdateCurrentColor ( void )
{
	fg_setcolor ( CurrentColor ) ;
	fg_rect ( 300 , 340 , 10 , 50 ) ;
}

int Benchmark ( BENCHMARK_RESULT * BM )
{
	double			FrameSpeed ;
	int				FrameLength ;
	int				I , Counter , Time ;
	struct time		Original , Use ;
	char				Buffer [ 8 * 16 ] ;


	fg_setmode ( 18 ) ;
	fg_setcolor ( 15 ) ;
	fg_move ( 2 , 478 ) ;
	fg_print ( "PLEASE WAIT" , 11 ) ;
	for ( I = 1 ; I < 15 ; I ++ )
	{
		fg_setrgb ( I , 0 , 0 , 0 ) ;
	}
	fg_setcolor ( 4 ) ;
	fg_rect ( 0 , 15 , 0 , 15 ) ;
	fg_move ( 0 , 15 ) ;
	fg_getimage ( Buffer , 8 , 16 ) ;
	gettime ( & Original ) ;
	Use . ti_hour = 0 ;
	Use . ti_min = 0 ;
	Use . ti_sec = 0 ;
	Use . ti_hund = 0 ;
	settime ( & Use ) ;
	Counter = 0 ;
	Time = 0 ;
	while ( Time < BenchmarkTime )
	{
		fg_move ( 320 , 200 ) ;
		fg_putimage ( Buffer , 8 , 16 ) ;
		Counter ++ ;
		gettime ( & Use ) ;
		Time = ( Use . ti_hund + ( Use . ti_sec * 100 ) ) * 10 ;
	}
	settime ( & Original ) ;

	FrameSpeed = (double) Counter / (double) Time ;
	(* BM) . Speed = (int) FrameSpeed ;
	FrameLength = 1000 / FrameRate ;
	for ( I = 1 ; I < 6 ; I ++ )
	{
		(* BM) . Delay [ I ] =
				FrameLength - (int) ( FrameSpeed * (double) I ) ;
		if ( (* BM) . Delay [ I ] < 0 )
		{
			return ( -1 ) ;
		}
	}
	if ( (* BM) . Speed < 0 )
	{
		return ( -1 ) ;
	}
	return ( 1 ) ;
}

void Play ( void )
{
	int		I , X , Y , K , J ;
	int		Blank , LastFrame = 0 ;
	char		* Buffer [ 126 ] ;

	for ( I = 0 ; I < 126 ; I ++ )
	{
		Buffer [ I ] = malloc ( 8 * 16 ) ;
		if ( Buffer [ I ] == NULL )
		{
			fg_setmode ( 3 ) ;
			printf ( "Out of memory!" ) ;
			exit ( 0 ) ;
		}
	}
	I = 0 ;
	Blank = 0 ;
	while ( ! Blank && I < SectFrames )
	{
		Blank = 1 ;
		J = 0 ;
		for ( Y = GridSize - 1 ; Y > -1 ; Y -- )
		{
			for ( X = 0 ; X < GridSize ; X += 2 )
			{
				K = ( Sect [ I ][ X ][ Y ] * 16 ) + ( Sect [ I ][ X + 1 ][ Y ] ) ;
				if ( K > 0 )
				{
					Blank = 0 ;
				}
				Buffer [ I ][ J ] = K ;
				J ++ ;
			}
		}
		I ++ ;
	}
	LastFrame = I ;
	if ( LastFrame < 2 )
	{
		for ( I = 0 ; I < 126 ; I ++ )
		{
			free ( Buffer [ I ] ) ;
		}
		return ;
	}
	for ( I = 0 ; I < LastFrame ; I ++ )
	{
		fg_move ( 75 - ( SqSize / 2 ) ,
			( 365 - ( SqSize / 2 ) ) + GridSize - 1 ) ;
		fg_putimage ( Buffer [ I ] , 8 , 16 ) ;
		delay ( BenchmarkResult . Delay [ 1 ] ) ;
	}
	UpdateAll () ;
	for ( I = 0 ; I < 126 ; I ++ )
	{
		free ( Buffer [ I ] ) ;
	}
}

void UpdateDrag ( void )
{
	if ( Drag )
	{
		strcpy ( Temp , "ON " ) ;
	} else {
		strcpy ( Temp , "OFF" ) ;
	}
	fg_setcolor ( 0 ) ;
	fg_rect ( 610 , 639 , 200 , 250 ) ;
	fg_setcolor ( 7 ) ;
	fg_move ( 610 , 240 ) ;
	fg_print ( Temp , 3 ) ;
}

void MouseAt ( int X , int Y )
{
	char		Was [ 128 ] ;

	fg_move ( X - 8 , Y + 8 ) ;
	fg_getimage ( Was , 8 , 16 ) ;
	fg_setcolor ( 14 ) ;
	fg_move ( X - 8 , Y + 8 ) ;
	fg_drawx ( X + 7 , Y - 7 ) ;
	fg_move ( X - 8 , Y - 7 ) ;
	fg_drawx ( X + 7 , Y + 8 ) ;
	fg_move ( X - 8 , Y + 8 ) ;
	delay ( 15 ) ;
	fg_putimage ( Was , 8 , 16 ) ;
}

