/*
Amulet.

Level player.

(C) J Whitham 1994
*/

#include <fastgraf.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#define MaxX				( 40 )
#define MaxY				( 28 )
#define GridSize			( 16 )
#define BenchmarkTime	( 2000 )
#define FrameRate			( 20 )
#define DataFile1			( "AMULET.001" )
#define DataFile2			( "AMULET.002" )
#define DataFile3			( "AMULET.003" )
#define DataFile4			( "AMULET.004" )


typedef struct {
						unsigned char	RedKeys ;
						unsigned char	GreenKeys ;
						unsigned char	BlueKeys ;
						unsigned long	Score ;
						char				Stealth ;
						char				Mana ;
						char				Strength ;
						char				Experience ;
						unsigned char	Health ;
						unsigned char	Food ;
						unsigned long	Moves ;
						unsigned long	Money ;
						unsigned char	Hammers ;
						unsigned char	Weight ;
						unsigned char	X , Y ;
						unsigned char	Alive ;
						unsigned int	FoodTimer ;
						} CHARACTER ;


typedef struct {
						int			Speed ;
						int			Delay [ 6 ] ;
						} BM_RESULT ;

typedef struct {
						unsigned char		Type ;
						unsigned char		X , Y ;
						} MONSTER ;


unsigned char		APassword [ 6 ] = { "lurgI" } ;
unsigned char		Screen [ MaxX ][ MaxY ] ;
unsigned char		ScrMask [ MaxX ][ MaxY ] ;
fpos_t				LevelStart ;
char					* StaticChar [ 256 ] ;
char					Temp [ 40 ] ;
int					Red [ 16 ] , Green [ 16 ] , Blue [ 16 ] ;
CHARACTER			Character ;
CHARACTER			Old ;
char					* CharAnim [ 100 ][ 60 ] ;
char					MaskText [ 100 ][ 76 ] ;
unsigned char		MonstersOnLevel ;
MONSTER				Monsters [ 256 ] ;
FILE					* File1 ;
FILE					* File2 ;
FILE					* Input ;
int					I , SFX = 0 , J , Cheats = 0 , Reveal = 1 , PlayReal = 0 ;
char					Direction ;
unsigned char		Original [ 16 ][ 16 ] ;
BM_RESULT			BenchmarkResult ;
int					WentUpTo ;


int PlayLev ( int Picked ) ;
void Convert ( char * Anim ) ;
void InitAnimations ( void ) ;
void FreeAnimations ( void ) ;
void Load1Way ( char * Anim [] , int Frames ) ;
void Load4Way ( char * Anim1 [] , char * Anim2 [] ,
	char * Anim3 [] , char * Anim4 [] , int Frames ) ;
int Benchmark ( BM_RESULT * BM ) ;
void StraightConvert ( char * Anim ) ;
void UpDownConvert ( char * Anim ) ;
void RotateRightConvert ( char * Anim ) ;
void RotateLeftConvert ( char * Anim ) ;
void WrLong ( unsigned long I ) ;
void WrInt ( int I ) ;
void FreeMem ( void ) ;
void Update ( int X , int Y ) ;
void DrawChar ( int X , int Y ) ;
void Blank ( int X , int Y ) ;
void DoHammer ( void ) ;
void Zonk ( int X , int Y ) ;
void UpdateScr ( void ) ;
void Show ( char * Anim , int X , int Y ) ;
void LoadAllData ( void ) ;
int LoadLevel ( int Level ) ;
void OutOfMemory ( void ) ;
void DoTeleport ( void ) ;
void PlayDual ( int X1 , int Y1 , char * Animation1 [] , int SaFrame1 , int StFrame1 ,
					int X2 , int Y2 , char * Animation2 [] , int SaFrame2 , int StFrame2 ,
					int Speed ) ;
void Message ( char Text [] ) ;


void main ( int arg_c , char * arg_v [] )
{
	int		I , J ;
	int		Picked ;

	if ( fg_getmode () != 3 )
	{
		fg_setmode ( 3 ) ;
	} else {
		fg_setmode ( -1 ) ;
	}
	fg_setattr ( 14 , 1 , 0 ) ;
	printf ( "\n\n" ) ;
	fg_text ( " Level Player (C) J Whitham 1994  'Amulet' " , 43 ) ;
	printf ( "\n\n" ) ;
	fg_setattr ( 7 , 0 , 0 ) ;
	if ( ! fg_testmode ( 18 , 1 ) )
	{
		printf ( "\nFatal error: Requires VGA" ) ;
		FreeMem () ;
		exit ( 0 ) ;
	}
	if ( arg_c > 1 )
	{
		for ( I = 1 ; I < arg_c ; I ++ )
		{
			strlwr ( arg_v [ I ] ) ;
			for ( J = 0 ; J < strlen ( arg_v [ I ] ) ; J ++ )
			{
				switch ( arg_v [ I ][ J ] )
				{
					case 's' :		SFX = 1 ;
										break ;
					case 'c' :		Cheats = 1 ;
										break ;
					case 'r' :		Reveal = 1 ;
										break ;
					case '-' :		PlayReal = 1 ;
										break ;
				}
			}
		}
	}
	if ( Cheats )
	{
		printf ( "CHEATS ON\n\n" ) ;
	}
	if ( SFX )
	{
		printf ( "Enter advanced password:" ) ;
		SFX = 1 ;
		for ( I = 0 ; I < 5 ; I ++ )
		{
			if ( getch () != APassword [ I ] )
			{
				SFX = 0 ;
				break ;
			}
		}
		if ( SFX )
		{
			printf ( " OK\a\n\n" ) ;
		} else {
			printf ( " SORRY\n\n" ) ;
		}
	}
	printf ( "%ld bytes memory free\n\n" , fg_memavail () ) ;

	printf ( "Loading please wait..." ) ;
	LoadAllData () ;
	printf ( "done\n\n" ) ;
	Character . Score = 0 ;
	Character . Moves = 0 ;
	Character . Food = 100 ;
	Character . Health = 100 ;
	Character . Experience = 1 ;
	Character . Mana = 5 ;
	Character . Strength = 5 ;
	Character . Stealth = 5 ;
	Character . Money = 0 ;
	Character . Alive = 1 ;
	Character . FoodTimer = 15 ;
/*	if ( Reveal )
	{
		for ( I = 1 ; I < 256 ; I ++ )
		{
			if ( Level [ I ] != NULL )
			{
				printf ( "%4d" , I ) ;
			}
		}
	}*/
	InitAnimations () ;
	if ( ! PlayReal )
	{
		fg_setmode ( 3 ) ;
		printf ( "Benchmark is %d\%" , BenchmarkResult . Delay [ 1 ] * 2 ) ;
		printf ( "\n\nEnter level number: " ) ;
		gets ( Temp ) ;
		Picked = atoi ( Temp ) ;
		printf ( "\n\n" ) ;
		if ( Picked < 1 || Picked > 255 )
		{
			printf ( "Bad level!" ) ;
			exit ( 0 ) ;
		}
		PlayLev ( Picked ) ;
	} else {
		Picked = 1 ;
		while ( Picked != 0 )
		{
			fg_setmode ( 3 ) ;
			I = PlayLev ( Picked ) ;
			if ( I == 0 )
			{
				printf ( "\n\nGoodbye, and thanks for playing..\n" ) ;
				FreeMem () ;
				FreeAnimations () ;
				exit ( 0 ) ;
			} else {
				if ( I < 0 )
				{
					Picked -- ;
				} else {
					Picked ++ ;
				}
				if ( Picked < 1 || Picked > 255 )
				{
					Picked = 1 ;
				}
			}
		}
	}
	FreeMem () ;
	FreeAnimations () ;
}

int PlayLev ( int Picked )
{
	int		R , G , B ;
	int		Ins = 0 ;
	int		Outs = 0 ;
	int		Doors1 = 0 ;
	int		Doors2 = 0 ;
	int		Doors3 = 0 ;
	int		Keys1 = 0 ;
	int		Keys2 = 0 ;
	int		Keys3 = 0 ;
	int		X , Y , I ;
	int		OldX , OldY , InX , InY ;
	int		DirCalc ;
	int		Warn = 0 , Fatal = 0 ;
	int		Quit = 0 , Won = 0 ;

	Character . RedKeys = 0 ;
	Character . GreenKeys = 0 ;
	Character . BlueKeys = 0 ;
	printf ( "Loading level.." ) ;
	if ( ! LoadLevel ( Picked ) )
	{
		printf ( "\n\nThis level does not exist" ) ;
		return ( 0 ) ;
	}
	fg_setmode ( 3 ) ;
	printf ( "Checking level structure..\n" ) ;
	fg_waitfor ( 2 ) ;
	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			switch ( Screen [ X ][ Y ] )
			{
				case 136 :		Ins ++ ;
									InX = X ;
									InY = Y ;
									break ;
				case 137 :		Outs ++ ;
									break ;
				case 143 :		Keys1 ++ ;
									break ;
				case 144 :		Keys2 ++ ;
									break ;
				case 145 :		Keys3 ++ ;
									break ;
				case 146 :		Doors1 ++ ;
									break ;
				case 147 :		Doors2 ++ ;
									break ;
				case 148 :		Doors3 ++ ;
									break ;
			}
		}
	}
	Character . X = InX ;
	Character . Y = InY ;
	if ( ( InX > 0 && InY > 0 )
	&& ( InX < MaxX - 1 && InY < MaxY - 1 ) )
	{
		if ( Screen [ InX - 1 ][ InY ] == 1 )
		{
			Character . X = InX - 1 ;
		} else {
			if ( Screen [ InX ][ InY - 1 ] == 1 )
			{
				Character . Y = InY - 1 ;
			} else {
				if ( Screen [ InX + 1 ][ InY ] == 1 )
				{
					Character . X = InX + 1 ;
				} else {
					if ( Screen [ InX ][ InY + 1 ] == 1 )
					{
						Character . Y = InY + 1 ;
					} else {
						printf ( "Fatal error: Your entrance is completely surrounded.\n" ) ;
						Fatal = 1 ;
					}
				}
			}
		}
	} else {
		printf ( "Fatal error: Your entrance is on the edge of the screen\n\n" ) ;
		Fatal = 1 ;
	}
	if ( Ins < 1 )
	{
		printf ( "Fatal error: You don't have an entrance!\n" ) ;
		Fatal = 1 ;
	}
	if ( Ins > 1 )
	{
		printf ( "Fatal error: You have too many entrances!\n" ) ;
		Fatal = 1 ;
	}
	if ( Outs < 1 )
	{
		printf ( "Fatal error: You don't have an exit!\n" ) ;
		Fatal = 1 ;
	}
	if ( Outs > 1 )
	{
		printf ( "Warning: You have more than one exit.\n" ) ;
		Warn = 1 ;
	}
	if ( Keys1 < Doors1 )
	{
		printf ( "Warning: You have more doors (type 1) than keys (type 1)\n" ) ;
		Warn = 1 ;
	}
	if ( Keys1 > Doors1 )
	{
		printf ( "Warning: You have more keys (type 1) than doors (type 1)\n" ) ;
		Warn = 1 ;
	}
	if ( Keys2 < Doors2 )
	{
		printf ( "Warning: You have more doors (type 2) than keys (type 2)\n" ) ;
		Warn = 1 ;
	}
	if ( Keys2 > Doors2 )
	{
		printf ( "Warning: You have more keys (type 2) than doors (type 2)\n" ) ;
		Warn = 1 ;
	}
	if ( Keys3 < Doors3 )
	{
		printf ( "Warning: You have more doors (type 3) than keys (type 3)\n" ) ;
		Warn = 1 ;
	}
	if ( Keys3 > Doors3 )
	{
		printf ( "Warning: You have more keys (type 3) than doors (type 3)\n" ) ;
		Warn = 1 ;
	}
	if ( Fatal )
	{
		printf ( "\n\n" ) ;
		return ( 0 ) ;
	}
	if ( Warn )
	{
		printf ( "\n\nPress any key to continue..." ) ;
		(void) getch () ;
	}
	fg_setmode ( 18 ) ;
	for ( I = 0 ; I < 16 ; I ++ )
	{
		fg_getrgb ( I , & Red [ I ] , & Green [ I ] , & Blue [ I ] ) ;
		fg_setrgb ( I , 0 , 0 , 0 ) ;
	}
	for ( X = 0 ; X < MaxX ; X ++ )
	{
		for ( Y = 0 ; Y < MaxY ; Y ++ )
		{
			Update ( X , Y ) ;
		}
	}
	Old . RedKeys = 1 ;
	Old . Hammers = 1 ;
	Old . Strength = 1 ;
	Old . Score = 4 ;
	UpdateScr () ;
	fg_setcolor ( 15 ) ;
	fg_fontsize ( 8 ) ;
	fg_move ( 0 , 479 ) ;
	fg_draw ( 0 , 448 ) ;
	fg_draw ( 639 , 448 ) ;
	fg_move ( 0 , 469 ) ;
	fg_draw ( 639 , 469 ) ;
	fg_move ( 0 , 479 ) ;
	fg_draw ( 639 , 479 ) ;
	fg_move ( 120 , 448 ) ;
	fg_draw ( 120 , 469 ) ;
	fg_move ( 230 , 448 ) ;
	fg_draw ( 230 , 469 ) ;
	fg_move ( 318 , 448 ) ;
	fg_draw ( 318 , 469 ) ;
	fg_move ( 438 , 448 ) ;
	fg_draw ( 438 , 469 ) ;
	fg_move ( 560 , 448 ) ;
	fg_draw ( 560 , 469 ) ;
	fg_move ( 639 , 448 ) ;
	fg_draw ( 639 , 479 ) ;

	fg_setcolor ( 7 ) ;
	/* Column 1 */
	fg_move ( 2 , 468 ) ;
	fg_print ( "Stealth:" , 8 ) ;
	fg_move ( 2 , 458 ) ;
	fg_print ( "Keys   :" , 8 ) ;
	/* Column 2 */
	fg_move ( 122 , 458 ) ;
	fg_print ( "Hammers:" , 8 ) ;
	fg_move ( 122 , 468 ) ;
	fg_print ( "Health%:" , 8 ) ;
	/* Column 3 */
	fg_move ( 232 , 458 ) ;
	fg_print ( "Str. :" , 6 ) ;
	fg_move ( 232 , 468 ) ;
	fg_print ( "Food%:" , 6 ) ;
	/* Column 4 */
	fg_move ( 320 , 458 ) ;
	fg_print ( "SCORE:" , 6 ) ;
	fg_move ( 320 , 468 ) ;
	fg_print ( "MOVES:" , 6 ) ;
	/* Column 5 */
	fg_move ( 440 , 458 ) ;
	fg_print ( "GOLD:" , 5 ) ;
	fg_move ( 440 , 468 ) ;
	fg_print ( "Exp.:" , 5 ) ;
	/* Column 6 */
	fg_move ( 562 , 458 ) ;
	fg_print ( "Mana:" , 5 ) ;
	fg_move ( 562 , 468 ) ;
	fg_print ( "Wght:" , 5 ) ;

	for ( X = 0 ; X < 64 ; X += 8 )
	{
		for ( I = 0 ; I < 16 ; I ++ )
		{
			R = Red [ I ] ;
			G = Green [ I ] ;
			B = Blue [ I ] ;
			if ( R > X )
			{
				R = X ;
			}
			if ( G > X )
			{
				G = X ;
			}
			if ( B > X )
			{
				B = X ;
			}
			fg_setrgb ( I , R , G , B ) ;
		}
	}
	WentUpTo = X ;
	Direction = 2 ;
	fg_kbinit ( 1 ) ;
	sprintf ( Temp , "Welcome to level %d!" , Picked ) ;
	DrawChar ( Character . X , Character . Y ) ;
	Message ( Temp ) ;

	while ( ! Quit && Character . Alive )
	{
		DrawChar ( Character . X , Character . Y ) ;
		OldX = Character . X ;
		OldY = Character . Y ;
		while ( OldX == Character . X
		&& OldY == Character . Y
		&& ! Quit
		&& Character . Alive )
		{
			if ( fg_kbtest ( 80 ) )
			{
				Character . Y ++ ; /* down */
				Direction = 2 ;
			} else {
				if ( fg_kbtest ( 72 ) )
				{
					Character . Y -- ; /* up */
					Direction = 8 ;
				} else {
					if ( fg_kbtest ( 77 ) )
					{
						Character . X ++ ; /* right */
						Direction = 6 ;
					} else {
						if ( fg_kbtest ( 75 ) )
						{
							Character . X -- ; /* left */
							Direction = 4 ;
						} else {
							if ( fg_kbtest ( 57 ) )
							{
								DoHammer () ;
							}
							if ( fg_kbtest ( 15 ) ) /* tab */
							{
								DoTeleport () ;
							}
							Direction = -1 ;
						}
					}
				}
			}
			if ( fg_kbtest ( 1 ) )
			{
				Quit = 1 ;
			}
			switch ( Screen [ Character . X ][ Character . Y ] )
			{
				case 136 :  Quit = 1 ;
								Won = 2 ;
								break ;
				case 137 :	Quit = 1 ;
								Won = 1 ;
								break ;
				case 143 :	Character . RedKeys ++ ;
								Blank ( Character . X , Character . Y ) ;
								Character . Score += 100 ;
								break ;
				case 144 :	Character . GreenKeys ++ ;
								Blank ( Character . X , Character . Y ) ;
								Character . Score += 100 ;
								break ;
				case 145 :	Character . BlueKeys ++ ;
								Blank ( Character . X , Character . Y ) ;
								Character . Score += 100 ;
								break ;
				case 146 :	if ( Character . RedKeys > 0 )
								{
									Character . RedKeys -- ;
									Blank ( Character . X , Character . Y ) ;
									Character . Score += 1000 ;
									Update ( Character . X , Character . Y ) ;
									Message ( "The red door opens" ) ;
								} else {
									Message ( "This door requires a red key" ) ;
								}
								Character . X = OldX ;
								Character . Y = OldY ;
								break ;
				case 147 :	if ( Character . GreenKeys > 0 )
								{
									Character . GreenKeys -- ;
									Blank ( Character . X , Character . Y ) ;
									Character . Score += 1000 ;
									Update ( Character . X , Character . Y ) ;
									Message ( "The green door opens" ) ;
								} else {
									Message ( "This door requires a green key" ) ;
								}
								Character . X = OldX ;
								Character . Y = OldY ;
								break ;
				case 148 :	if ( Character . BlueKeys > 0 )
								{
									Character . BlueKeys -- ;
									Blank ( Character . X , Character . Y ) ;
									Update ( Character . X , Character . Y ) ;
									Character . Score += 1000 ;
									Message ( "The blue door opens" ) ;
								} else {
									Message ( "This door requires a blue key" ) ;
								}
								Character . X = OldX ;
								Character . Y = OldY ;
								break ;
				case 149 :  if ( Character . Experience >=
									ScrMask [ Character . X ][ Character . Y ] )
								{
									Blank ( Character . X , Character . Y ) ;
									Update ( Character . X , Character . Y ) ;
									Character . Score += 1000 ;
									Message ( "The experience door opens" ) ;
								} else {
									sprintf ( Temp , "This door requires %d experience points to open" ,
													ScrMask [ Character . X ][ Character . Y ] ) ;
									Message ( Temp ) ;
								}
								Character . X = OldX ;
								Character . Y = OldY ;
								break ;
				case 138 :	Character . Score += 1000 ;
								Character . Money += 100 ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 139 :	Character . Score += 5000 ;
								Character . Money += 500 ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 140 :	Character . Score += 500 ;
								Character . Money += 50 ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 141 :	Character . Score += 500 ;
								Character . Money += 50 ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 142 :	Character . Score += 2500 ;
								Character . Money += 250 ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 151 :	Character . Score += 1000 ;
								Character . Food += 50 ;
								if ( Character . Food > 100 )
								{
									Character . Food = 100 ;
								}
								Message ( "You found some food" ) ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 156 :	Character . Score += 500 ;
								Blank ( Character . X , Character . Y ) ;
								Character . Hammers ++ ;
								Message ( "You found a hammer" ) ;
								break ;
				case 154 :	Character . Alive = 0 ;
								break ;
				case 155 :	Character . Alive = 0 ;
								break ;
				case 153 :	Character . Alive = 0 ;
								break ;
				case 167 :	Character . Health += 50 ;
								if ( Character . Health > 100 )
								{
									Character . Health = 100 ;
								}
								Message ( "You found a first aid kit" ) ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 1 :		break ;
				case 150 :  Character . Score +=
									(int) ScrMask [ Character . X ][ Character . Y ] * 10 ;
								Character . Money +=
									(int) ScrMask [ Character . X ][ Character . Y ] ;
								Blank ( Character . X , Character . Y ) ;
								break ;
				case 162 :	Message ( MaskText [
									ScrMask [ Character . X ][ Character . Y ] ] ) ;
								Blank ( Character . X , Character . Y ) ;
								Update ( Character . X , Character . Y ) ;
								Character . X = OldX ;
								Character . Y = OldY ;
								break ;
				default :	Character . X = OldX ;
								Character . Y = OldY ;
								break ;
			}
			UpdateScr () ;
		}

		if (( Character . X != OldX || Character . Y != OldY )
		&& ( Direction != -1 ))
		{
			if ( Character . FoodTimer == 0 )
			{
				Character . FoodTimer = 16 ;
				Character . Food -- ;
				UpdateScr () ;
			}
			Character . FoodTimer -- ;
			switch ( Direction )
			{
				case 8 :		DirCalc = 0 ;
								break ;
				case 2 :		DirCalc = 1 ;
								break ;
				case 4 :		DirCalc = 2 ;
								break ;
				case 6 :		DirCalc = 3 ;
								break ;
			}
			switch ( Screen [ Character . X ][ Character . Y ] )
			{
				case 154 :			PlayDual ( OldX , OldY , CharAnim[ DirCalc + 1 ] , 0 , 16 ,
														Character . X , Character . Y ,
														CharAnim[ DirCalc + 9 ] , 8 , 55 , 1 ) ;
										break ;
				case 155 :			PlayDual ( OldX , OldY , CharAnim[ DirCalc + 1 ] , 0 , 16 ,
														Character . X , Character . Y ,
														CharAnim[ DirCalc + 13 ] , 8 , 25 , 1 ) ;
										break ;
				case 153 :			PlayDual ( OldX , OldY , CharAnim[ DirCalc + 1 ] ,
														0 , 16 , Character . X , Character . Y ,
														CharAnim[ DirCalc + 17 ] , 8 , 29 , 1 ) ;
										break ;
				default :			PlayDual ( OldX , OldY , CharAnim[ DirCalc + 1 ] ,
														0 , 16 , Character . X , Character . Y ,
														CharAnim[ DirCalc + 5 ] , 8 , 19 , 2 ) ;
			}
			Update ( OldX , OldY ) ;
		}
		Character . Moves ++ ;
	}
	if ( ! fg_kbtest ( 1 ) )
	{
		Message ( "Press any key to continue.." ) ;
		fg_kbinit ( 0 ) ;
		fg_waitkey () ;
	} else {
		fg_kbinit ( 0 ) ;
	}
	for ( X = WentUpTo ; X > 0 ; X -= 8  )
	{
		for ( I = 0 ; I < 16 ; I ++ )
		{
			R = Red [ I ] ;
			G = Green [ I ] ;
			B = Blue [ I ] ;
			if ( R > X )
			{
				R = X ;
			}
			if ( G > X )
			{
				G = X ;
			}
			if ( B > X )
			{
				B = X ;
			}
			fg_setrgb ( I , R , G , B ) ;
		}
	}

	fg_setmode ( 3 ) ;
	if ( ( ! Character . Alive )
	|| ( Character . Alive && ! Won ) )
	{
		fg_locate ( 1 , 1 ) ;
		fg_setattr ( 14 , 1 , 0 ) ;
		fg_text ( " 'AMULET' " , 10 ) ;
		fg_setattr ( 14 , 0 , 0 ) ;
		fg_text ( " Your closing scores are:" , 25 ) ;
		fg_setattr ( 7 , 0 , 0 ) ;
		fg_locate ( 5 , 0 ) ;
		if ( ! Character . Alive )
		{
			strcpy ( Temp , "died" ) ;
		} else {
			if ( Won )
			{
				if ( Won == 1 )
				{
					strcpy ( Temp , "got to the exit" ) ;
				} else {
					strcpy ( Temp , "went back to the entrance" ) ;
				}
			} else {
				strcpy ( Temp , "gave up" ) ;
			}
		}
		printf ( "Score  : %16lu Moves  : %16lu\n" , Character . Score ,
																Character . Moves ) ;
		printf ( "Stealth: %3d Mana   : %3d Str.   : %3d Exp.   : %3d\n" ,
			Character . Stealth , Character . Mana ,
			Character . Strength , Character . Experience ) ;
		printf ( "Health : %3d Food   : %3d Hammers: %3d Weight : %3d\n" ,
			Character . Health , Character . Food ,
			Character . Hammers , Character . Weight ) ;
		printf ( "Gold   : %lu\n\n" , Character . Money ) ;
		printf ( "You %s on physical level %d\n\n" , Temp , Picked ) ;
		return ( 0 ) ;
	}
	if ( Won == 1 )
	{
		return ( 1 ) ;
	} else {
		if ( Won == 2 )
		{
			return ( -1 ) ;
		} else {
			return ( 0 ) ;
		}
	}
}

void FreeMem ( void )
{
	int		I ;


	for ( I = 1 ; I < 256 ; I ++ )
	{
		free ( StaticChar [ I ] ) ;
	}
}

void DrawChar ( int X , int Y )
{
	switch ( Direction )
	{
		case 8 :	Show ( CharAnim [ 1 ][ 0 ] , X , Y ) ;
					break ;
		case 6 :	Show ( CharAnim [ 4 ][ 0 ] , X , Y ) ;
					break ;
		case 4 : Show ( CharAnim [ 3 ][ 0 ] , X , Y ) ;
					break ;
		default :
					Show ( CharAnim [ 2 ][ 0 ] , X , Y ) ;
	}
}

void Update ( int X , int Y )
{
	fg_move ( X * GridSize , ( Y * GridSize ) + ( GridSize - 1 ) ) ;
	fg_putimage ( StaticChar [ Screen [ X ][ Y ] ] ,
							GridSize / 2 , GridSize ) ;
}

void Blank ( int X , int Y )
{
	Screen [ X ][ Y ] = 1 ;
}

void DoHammer ( void )
{
	int		I ;


	if ( Character . Hammers < 1 )
	{
		return ;
	}
	Character . Hammers -- ;
	for ( I = 0 ; I < 44 ; I ++ )
	{
		Show ( CharAnim[ 99 ][ I ] , Character . X , Character . Y ) ;
		delay ( BenchmarkResult . Delay [ 1 ] ) ;
		switch ( I )
		{
			case 12 :	Zonk ( Character . X + 1 , Character . Y ) ;
							break ;
			case 16 :	Zonk ( Character . X + 1 , Character . Y + 1 ) ;
							break ;
			case 18 :	Zonk ( Character . X , Character . Y + 1 ) ;
							break ;
			case 24 :	Zonk ( Character . X - 1 , Character . Y + 1 ) ;
							break ;
			case 27 :	Zonk ( Character . X - 1 , Character . Y ) ;
							break ;
			case 29 :	Zonk ( Character . X - 1 , Character . Y - 1 ) ;
							break ;
			case 30 :	Zonk ( Character . X , Character . Y - 1 ) ;
							break ;
			case 32 :	Zonk ( Character . X + 1 , Character . Y - 1 ) ;
							break ;
		}
		if ( SFX )
		{
			nosound () ;
		}
	}
}

void Zonk ( int X , int Y )
{
	int	Temp ;

	if ( X < 0 || Y < 0 || X > MaxX - 1 || Y > MaxY - 1 )
	{
		return ;
	}
	Temp = Screen [ X ][ Y ] ;
	if ( Temp == 160
	|| Temp == 159 )
	{
		Blank ( X , Y ) ;
		Update ( X , Y ) ;
		if ( SFX )
		{
			sound ( 50 ) ;
		}
	} else {
		if ( Temp == 161 )
		{
			Screen [ X ][ Y ] = 127 ; /* rubble */
			Update ( X , Y ) ;
			if ( SFX )
			{
				sound ( 30 ) ;
			}
		}
	}
}

void UpdateScr ( void )
{
	fg_fontsize ( 8 ) ;
	if ( ( Old . Stealth != Character . Stealth )
	|| ( Old . RedKeys != Character . RedKeys )
	|| ( Old . GreenKeys != Character . GreenKeys )
	|| ( Old . BlueKeys != Character . BlueKeys ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 74 , 119 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 74 , 468 ) ;
		WrInt ( Character . Stealth ) ;
		fg_setcolor ( 4 ) ;
		fg_move ( 74 , 458 ) ;
		WrInt ( Character . RedKeys ) ;
		fg_setcolor ( 2 ) ;
		fg_move ( 90 , 458 ) ;
		WrInt ( Character . GreenKeys ) ;
		fg_setcolor ( 1 ) ;
		fg_move ( 106 , 458 ) ;
		WrInt ( Character . BlueKeys ) ;
	}
	if ( ( Old . Hammers != Character . Hammers )
	|| ( Old . Health != Character . Health ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 194 , 229 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 194 , 458 ) ;
		WrInt ( Character . Hammers ) ;
		fg_move ( 194 , 468 ) ;
		WrInt ( Character . Health ) ;
	}

	if ( ( Old . Strength != Character . Strength )
	|| ( Old . Food != Character . Food ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 286 , 307 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 286 , 458 ) ;
		WrInt ( Character . Strength ) ;
		fg_move ( 286 , 468 ) ;
		WrInt ( Character . Food ) ;
	}

	if ( ( Old . Score != Character . Score )
	|| ( Old . Moves != Character . Moves ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 374 , 437 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 374 , 458 ) ;
		if ( Character . Score > 99999999L )
		{
			Character . Score = 99999999L ;
		}
		WrLong ( Character . Score ) ;
		fg_move ( 374 , 468 ) ;
		if ( Character . Moves > 99999999L )
		{
			Character . Moves = 99999999L ;
		}
		WrLong ( Character . Moves ) ;
	}
	if ( ( Old . Money != Character . Money )
	|| ( Old . Experience != Character . Experience ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 486 , 559 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 486 , 458 ) ;
		if ( Character . Money > 99999999L )
		{
			Character . Money = 99999999L ;
		}
		WrLong ( Character . Money ) ;
		fg_move ( 486 , 468 ) ;
		WrInt ( Character . Experience ) ;
	}
	if ( ( Old . Mana != Character . Mana )
	|| ( Old . Weight != Character . Weight ) )
	{
		fg_setcolor ( 0 ) ;
		fg_rect ( 608 , 638 , 449 , 468 ) ;
		fg_setcolor ( 3 ) ;
		fg_move ( 608 , 458 ) ;
		WrInt ( Character . Mana ) ;
		fg_move ( 608 , 468 ) ;
		WrInt ( Character . Weight ) ;
	}
	Old = Character ;
}

void WrInt ( int I )
{
	sprintf ( Temp , "%d" , I ) ;
	fg_print ( Temp , strlen ( Temp ) ) ;
}

void WrLong ( unsigned long I )
{
	sprintf ( Temp , "%lu" , I ) ;
	fg_print ( Temp , strlen ( Temp ) ) ;
}

/*
ANIMATION SECTION
*/


void InitAnimations ( void )
{
	fg_setmode ( 18 ) ;
	if ( Benchmark ( & BenchmarkResult ) < 0 )
	{
		fg_setmode ( 3 ) ;
		printf ( "This machine is too slow." ) ;
		exit ( 0 ) ;
	}
}

void Load1Way ( char * Anim [] , int Frames )
{
	int		I ;

	for ( I = 0 ; I < Frames ; I ++ )
	{
		Anim [ I ] = malloc ( 128 ) ;

		if ( Anim [ I ] == NULL )
		{
			fg_setmode ( 3 ) ;
			printf ( "Load1Way: Open file :Out of memory!" ) ;
			exit ( 0 ) ;
		}

		if ( fread ( Anim [ I ] , 128 , 1 , Input ) != 1 )
		{
			fg_setmode ( 3 ) ;
			printf ( "Load1Way: Open file :Couldn't load!" ) ;
			exit ( 0 ) ;
		}
	}
}

void Load4Way ( char * Anim1 [] , char * Anim2 [] ,
		char * Anim3 [] , char * Anim4 [] , int Frames )
{
	int		I ;

	for ( I = 0 ; I < Frames ; I ++ )
	{
		Anim1 [ I ] = malloc ( 128 ) ;
		Anim2 [ I ] = malloc ( 128 ) ;
		Anim3 [ I ] = malloc ( 128 ) ;
		Anim4 [ I ] = malloc ( 128 ) ;

		if (( Anim1 [ I ] == NULL )
		|| ( Anim2 [ I ] == NULL )
		|| ( Anim3 [ I ] == NULL )
		|| ( Anim4 [ I ] == NULL ))
		{
			fg_setmode ( 3 ) ;
			printf ( "Load4Way: Open file :Out of memory!" ) ;
			exit ( 0 ) ;
		}

		if (( fread ( Anim1 [ I ] , 128 , 1 , Input ) != 1 )
		|| ( fread ( Anim2 [ I ] , 128 , 1 , Input ) != 1 )
		|| ( fread ( Anim3 [ I ] , 128 , 1 , Input ) != 1 )
		|| ( fread ( Anim4 [ I ] , 128 , 1 , Input ) != 1 ))
		{
			fg_setmode ( 3 ) ;
			printf ( "Load4Way: Open file :Couldn't load!" ) ;
			exit ( 0 ) ;
		}
	}
}


void FreeAnimations ( void )
{
	int		J , K ;

	for ( J = 0 ; J < 100 ; J ++ )
	{
		for ( K = 0 ; K < 60 ; K ++ )
		{
			if ( CharAnim [ J ][ K ] != NULL )
			{
				free ( CharAnim [ J ][ K ] ) ;
			}
		}
	}
}

int Benchmark ( BM_RESULT * BM )
{
	double			FrameSpeed ;
	int				FrameLength ;
	int				I , Counter , Time ;
	struct time		Original , Use ;
	char				Buffer [ 8 * 16 ] ;


	fg_setmode ( 18 ) ;
	fg_setcolor ( 15 ) ;
	fg_move ( 2 , 478 ) ;
	fg_print ( "PLEASE WAIT" , 11 ) ;
	for ( I = 1 ; I < 15 ; I ++ )
	{
		fg_setrgb ( I , 0 , 0 , 0 ) ;
	}
	fg_setcolor ( 4 ) ;
	fg_rect ( 0 , 15 , 0 , 15 ) ;
	fg_move ( 0 , 15 ) ;
	fg_getimage ( Buffer , 8 , 16 ) ;
	gettime ( & Original ) ;
	Use . ti_hour = 0 ;
	Use . ti_min = 0 ;
	Use . ti_sec = 0 ;
	Use . ti_hund = 0 ;
	settime ( & Use ) ;
	Counter = 0 ;
	Time = 0 ;
	while ( Time < BenchmarkTime )
	{
		fg_move ( 320 , 200 ) ;
		fg_putimage ( Buffer , 8 , 16 ) ;
		Counter ++ ;
		gettime ( & Use ) ;
		Time = ( Use . ti_hund + ( Use . ti_sec * 100 ) ) * 10 ;
	}
	settime ( & Original ) ;

	FrameSpeed = (double) Counter / (double) Time ;
	(* BM) . Speed = (int) FrameSpeed ;
	FrameLength = 1000 / FrameRate ;
	for ( I = 1 ; I < 6 ; I ++ )
	{
		(* BM) . Delay [ I ] =
				FrameLength - (int) ( FrameSpeed * (double) I ) ;
		if ( (* BM) . Delay [ I ] < 0 )
		{
			return ( -1 ) ;
		}
	}
	if ( (* BM) . Speed < 0 )
	{
		return ( -1 ) ;
	}
	return ( 1 ) ;
}

void StraightConvert ( char * Anim )
{
	int	X , Y , K , J ;


	J = 0 ;
	for ( Y = 15 ; Y > -1 ; Y -- )
	{
		for ( X = 0 ; X < 16 ; X += 2 )
		{
			K = ( Original [ X ][ Y ] * 16 ) +
					Original [ X + 1 ][ Y ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}

void UpDownConvert ( char * Anim )
{
	int	X , Y , K , J ;

	J = 0 ;
	for ( Y = 0 ; Y < 16 ; Y ++ )
	{
		for ( X = 0 ; X < 16 ; X += 2 )
		{
			K = ( Original [ X ][ Y ] * 16 ) +
					Original [ X + 1 ][ Y ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}

void RotateLeftConvert ( char * Anim )
{
	int		X1 , Y1 , X2 , Y2 , J , K ;
	char		Original2 [ 16 ][ 16 ] ;

	X2 = 0 ;
	Y2 = 0 ;
	for ( X1 = 0 ; X1 < 16 ; X1 ++ )
	{
		for ( Y1 = 0 ; Y1 < 16 ; Y1 ++ )
		{
			Original2 [ X2 ][ Y2 ] = Original [ X1 ][ Y1 ] ;
			X2 ++ ;
			if ( X2 > 15 )
			{
				X2 = 0 ;
			}
		}
		Y2 ++ ;
	}

	J = 0 ;
	for ( Y1 = 0 ; Y1 < 16 ; Y1 ++ )
	{
		for ( X1 = 0 ; X1 < 16 ; X1 += 2 )
		{
			K = ( Original2 [ X1 ][ Y1 ] * 16 ) +
					Original2 [ X1 + 1 ][ Y1 ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}

void RotateRightConvert ( char * Anim )
{
	int		X1 , Y1 , X2 , Y2 , J , K ;
	char		Original2 [ 16 ][ 16 ] ;

	X2 = 0 ;
	Y2 = 0 ;
	for ( X1 = 0 ; X1 < 16 ; X1 ++ )
	{
		for ( Y1 = 0 ; Y1 < 16 ; Y1 ++ )
		{
			Original2 [ X2 ][ Y2 ] = Original [ X1 ][ Y1 ] ;
			X2 ++ ;
			if ( X2 > 15 )
			{
				X2 = 0 ;
			}
		}
		Y2 ++ ;
	}

	J = 0 ;
	for ( Y1 = 0 ; Y1 < 16 ; Y1 ++ )
	{
		for ( X1 = 15 ; X1 > -1 ; X1 -= 2 )
		{
			K = ( Original2 [ X1 ][ Y1 ] * 16 ) +
				 Original2 [ X1 - 1 ][ Y1 ] ;
			Anim [ J ] = K ;
			J ++ ;
		}
	}
}


void Show ( char * Anim , int X , int Y )
{
	fg_move ( X * GridSize , ( Y * GridSize ) + ( GridSize - 1 ) ) ;
	fg_putimage ( Anim , 8 , 16 ) ;
}

/*
LOADING SECTION
*/

void LoadAllData ( void )
{
	int				This , I ;
	unsigned char	L ;
/*	FILE				* File ;*/
	char				* Bad ;

	Input = fopen ( DataFile1 , "rb" ) ;
		/* now we will load the static chars. */
	if ( Input == NULL )
	{
		printf ( "\n\nFatal error: Can't load data file I" ) ;
		exit ( 0 ) ;
	}
	fread ( Temp , 16 , 1 , Input ) ;
	This = 0 ;
	while ( ! feof ( Input ) )
	{
		fread ( & L , 1 , 1 , Input ) ;
		This = (int) L ;
		StaticChar [ This ] = malloc ( 128 ) ;
		if ( StaticChar [ This ] == NULL )
		{
			OutOfMemory () ;
		}
		fread ( StaticChar [ This ] , 128 , 1 , Input ) ;
	}
	for ( I = 1 ; I < 256 ; I ++ )
	{
		if ( StaticChar [ I ] == NULL )
		{
			StaticChar [ I ] = malloc ( 128 ) ;
			if ( StaticChar [ I ] == NULL )
			{
				OutOfMemory () ;
			}
			memmove ( StaticChar [ I ] , StaticChar [ 2 ] , 128 ) ;
		}
	}
	fclose ( Input ) ;
	Input = fopen ( DataFile4 , "rb" ) ;
	/* animation data file */
	if ( Input == NULL )
	{
		printf ( "\n\nFatal error: Can't load data file IV" ) ;
		exit ( 0 ) ;
	}
	fread ( & Temp , 16 , 1 , Input ) ;
	Load4Way ( CharAnim[ 1 ] ,
					CharAnim[ 2 ] ,
					CharAnim[ 3 ] ,
					CharAnim[ 4 ] , 21 ) ;
	Bad = malloc ( 16384 ) ;
	Load4Way ( CharAnim[ 9 ] ,
					CharAnim[ 10 ] ,
					CharAnim[ 11 ] ,
					CharAnim[ 12 ] , 58 ) ;
	Load1Way ( CharAnim[ 99 ] , 45 ) ;
	Load4Way ( CharAnim[ 13 ] ,
					CharAnim[ 14 ] ,
					CharAnim[ 15 ] ,
					CharAnim[ 16 ] , 28 ) ;
	Load1Way ( CharAnim[ 98 ] , 25 ) ;
	Load4Way ( CharAnim[ 17 ] ,
					CharAnim[ 18 ] ,
					CharAnim[ 19 ] ,
					CharAnim[ 20 ] , 30 ) ;
	Load4Way ( CharAnim[ 5 ] ,
					CharAnim[ 6 ] ,
					CharAnim[ 7 ] ,
					CharAnim[ 8 ] , 21 ) ;
	fclose ( Input ) ;
	free ( Bad ) ;
}


void OutOfMemory ( void )
{
	printf ( "\n\nOut of memory\n" ) ;
	exit ( 0 ) ;
}

int LoadLevel ( int Level )
{
	int				This , I , J ;
	int				LevelDone = 0 , MaskDone = 0 ;
	unsigned char	L ;
	char				VoidDump [ 2048 ] ; /* level data not needed goes in here */
	FILE				* Input ;

	Input = fopen ( DataFile2 , "rb" ) ;
	/* Levels data file */
	fread ( & Temp , 16 , 1 , Input ) ;
	while ( ! feof ( Input ) )
	{
		fread ( & L , 1 , 1 , Input ) ;
		This = (int) L ;
		if ( This == Level )
		{
			fread ( Screen , 1120 , 1 , Input ) ;
			LevelDone = 1 ;
		} else {
			fread ( VoidDump , 1120 , 1 , Input ) ;
		}
	}
	fclose ( Input ) ;
	Input = fopen ( DataFile3 , "rb" ) ;
	fread ( & Temp , 16 , 1 , Input ) ;
	while ( ! feof ( Input ) )
	{
		fread ( & L , 1 , 1 , Input ) ;
		This = (int) L ;
		if ( This == Level )
		{
			fread ( ScrMask , 1120 , 1 , Input ) ;
			fread ( & L , 1 , 1 , Input ) ;
			for ( J = 0 ; J < (int) L ; J ++ )
			{
				fread ( MaskText [ J ] , 76 , 1 , Input ) ;
			}
			if ( L > 0 )
			{
				fread ( & L , 1 , 1 , Input ) ;
				MonstersOnLevel = (int) L ;
				if ( L > 0 )
				{
					for ( I = 1 ; I < L ; I ++ )
					{
						fread ( & Monsters [ I ] , 3 , 1 , Input ) ;
					}
				}
			}
			MaskDone = 1 ;
		} else {
			fread ( VoidDump , 1120 , 1 , Input ) ;
			fread ( & L , 1 , 1 , Input ) ;
			for ( J = 0 ; J < (int) L ; J ++ )
			{
				fread ( VoidDump , 76 , 1 , Input ) ;
			}
			if ( L > 0 )
			{
				fread ( & L , 1 , 1 , Input ) ;
				if ( L > 0 )
				{
					for ( J = 1 ; J < L ; J ++ )
					{
						fread ( VoidDump , 3 , 1 , Input ) ;
					}
				}
			}
		}
	}
	if ( LevelDone && ! MaskDone )
	{
		for ( I = 0 ; I < MaxX ; I ++ )
		{
			for ( J = 0 ; J < MaxY ; J ++ )
			{
				ScrMask [ I ][ J ] = 255 ;
			}
		}
		MonstersOnLevel = 0 ;
	}
	fclose ( Input ) ;
	return ( LevelDone ) ;
}

void DoTeleport ( void )
{
	int		I , Done = 0 ;
	int		LandX , LandY ;

	LandX = random ( MaxX ) ;
	LandY = random ( MaxY ) ;
	while ( Screen [ LandX ][ LandY ] != 1 )
	{
		LandX -- ;
		if ( LandX <= 0 )
		{
			LandX = 39 ;
			LandY -- ;
			if ( LandY <= 0 )
			{
				if ( ! Done )
				{
					LandX = 0 ;
					LandY = 0 ;
					Done = 1 ;
				} else {
					return ;
				}
			}
		}
	}
	for ( I = 0 ; I < 24 ; I ++ )
	{
		Show ( CharAnim [ 98 ][ I ] , Character . X , Character . Y ) ;
		if ( SFX )
		{
			sound ( I * 10 ) ;
		}
		delay ( BenchmarkResult . Delay [ 1 ] ) ;
		if ( SFX )
		{
			nosound () ;
		}
	}
	Update ( Character . X , Character . Y ) ;
	delay ( 500 ) ;
	for ( ; I >= 0 ; I -- )
	{
		Show ( CharAnim [ 98 ][ I ] , LandX , LandY ) ;
		if ( SFX )
		{
			sound ( I * 10 ) ;
		}
		delay ( BenchmarkResult . Delay [ 1 ] ) ;
		if ( SFX )
		{
			nosound () ;
		}
	}
	Character . X = LandX ;
	Character . Y = LandY ;
}

void PlayDual ( int X1 , int Y1 , char * Animation1 [] , int SaFrame1 , int StFrame1 ,
					int X2 , int Y2 , char * Animation2 [] , int SaFrame2 , int StFrame2 ,
					int Speed )
{
	int		Counter = SaFrame1 ;
	int		To = StFrame1 ;
	int		Shown ;

	if ( StFrame2 > To )
	{
		To = StFrame2 ;
	}
	if ( SaFrame2 < Counter )
	{
		Counter = SaFrame2 ;
	}
	for ( ; Counter <= To ; Counter += Speed )
	{
		Shown = 0 ;
		if ( ( Counter >= SaFrame1 ) && ( Counter <= StFrame1 ) )
		{
			Show ( Animation1 [ Counter ] , X1 , Y1 ) ;
			Shown ++ ;
		}
		if ( ( Counter >= SaFrame2 ) && ( Counter <= StFrame2 ) )
		{
			Show ( Animation2 [ Counter ] , X2 , Y2 ) ;
			Shown ++ ;
		}
		delay ( BenchmarkResult . Delay [ Shown ] ) ;
	}
}


void Message ( char Text [] )
{
	char		Buffer [ ( 640 * 32 ) / 2 ] ;

	fg_setcolor ( 0 ) ;
	fg_rect ( 1 , 638 , 470 , 478 ) ;
	fg_setcolor ( 14 ) ;
	fg_fontsize ( 8 ) ;
	fg_move ( 320 - ( strlen ( Text ) * 4 ) , 478 ) ;
	fg_print ( Text , strlen ( Text ) ) ;
}

/*

naming conventions for all characters

	1 - Walking Up Off the screen
	2 - Walking Dn Off the screen
	3 - Walking Lt Off the screen
	4 - Walking Rt Off the screen
	5 - Walking Up onto the screen
	6 - Walking Dn "
	7 - Walking Lt "
	8 - Walking Rt "

naming conventions for complex characters

	9 - Drowning Up onto screen
	10 - Drowning Dn "
	11 - Drowning Lt "
	12 - Drowning Rt "
	13 - Falling in pit up "
	14 -       "        dn "
	15 - " lt "
	16 - " rt "
	17 - Falling in trap up onto screen
	18 - " dn "
	19 - " lt "
	20 - " rt "

naming conventions for simple characters

specialized names for character

	99 - Hammer
	98 - Teleport


*/

